
#include <windows.h>            // Window defines
#include <gl\gl.h>              // OpenGL
#include <gl\glu.h>             // GLU library
#include <stdio.h>
#include <math.h>				// Define for sqrt
#include "resource.h"           // About box resource identifiers.

#include "Dialogbox.h"

//extern "C"
//{
	extern HWND hDlgModeless;
	extern BOOL updateOutput;
//}
// Dialog procedure.
BOOL CALLBACK ThresholdProc(HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	static ThresholdStruct oldData;
	static ThresholdStruct *data;
	static int limit = RANGE;
	char str[64];
	HWND	hCtrl, hwndParent;
	int		i, iIndex, iCtrlID;
	char comboStr[3][32] = {"Pos", "Neg", "Both"};
	
	switch (message)
	{
		// Initialize the dialog box
	case WM_INITDIALOG:
		{
			data = (ThresholdStruct*) lParam;
			oldData = *data;
			
			if (lParam != NULL)
			{
				for (i = 0; i < 3; i++)
				{
					hCtrl = GetDlgItem(hDlg, IDC_COMBO1 + i);
					SendMessage(hCtrl, CB_ADDSTRING, 0, (LPARAM) "Pos");
					SendMessage(hCtrl, CB_ADDSTRING, 0, (LPARAM) "Neg");
					SendMessage(hCtrl, CB_ADDSTRING, 0, (LPARAM) "Both");
					SendMessage(hCtrl, CB_SETCURSEL, data->sign[i] - 1, 0);

					CheckDlgButton(hDlg, IDC_POSITIVE + i, data->positive[i]);
					CheckDlgButton(hDlg, IDC_BW + i, data->blackwhite[i]);
					SetDlgItemInt(hDlg, IDC_EDIT_MEAN + i, data->curve[i], TRUE);
					hCtrl = GetDlgItem(hDlg, IDC_SCROLLBAR_MEAN + i);
					SetScrollRange(hCtrl, SB_CTL, 0, limit, FALSE);
					SetScrollPos(hCtrl, SB_CTL, data->curve[i], TRUE);
				}
				return (TRUE);
			}
			else return (FALSE);				
		}
		break;
	case WM_HSCROLL:
		hCtrl = (HWND) lParam;
		iCtrlID = GetWindowLong(hCtrl, GWL_ID);
		iIndex = iCtrlID - IDC_SCROLLBAR_MEAN;
		
		switch (LOWORD(wParam))
		{
		case SB_PAGEDOWN:
			data->curve[iIndex] += 9;
		case SB_LINEDOWN:
			data->curve[iIndex] = min(limit, data->curve[iIndex]+1);
			break;
		case SB_PAGEUP:
			data->curve[iIndex] -= 9;
		case SB_LINEUP:
			data->curve[iIndex] = max(-limit, data->curve[iIndex]-1);
			break;
		case SB_TOP:
			data->curve[iIndex] = -limit;
			break;
		case SB_BOTTOM:
			data->curve[iIndex] = limit;
			break;
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			data->curve[iIndex] = (short) HIWORD(wParam);
			if (data->curve[iIndex] > limit)
				data->curve[iIndex] = limit;
			else if (data->curve[iIndex] < -limit)
				data->curve[iIndex] = -limit;
			break;
		default:
			return FALSE;
		}
		SetScrollPos(hCtrl, SB_CTL, data->curve[iIndex], TRUE);
		SetDlgItemInt(hDlg, IDC_EDIT_MEAN + iIndex, data->curve[iIndex], TRUE);
		updateOutput = TRUE;
		
		return TRUE;
		// Process command messages
	case WM_COMMAND:      
		{
			UINT	id, oldVal;
			
			id = LOWORD(wParam);
			switch(id)
			{
			case IDC_COMBO1:
			case IDC_COMBO2:
			case IDC_COMBO3:
				i = id - IDC_COMBO1;
				hCtrl = GetDlgItem(hDlg, IDC_COMBO1 + i);
				oldVal = data->sign[i];
				data->sign[i] = SendMessage(hCtrl, CB_GETCURSEL, 0, 0) + 1;
				if (oldVal != data->sign[i])
					updateOutput = TRUE;
				return TRUE;
			case IDC_POSITIVE:
			case IDC_POSITIVE2:
			case IDC_POSITIVE3:
				i = id - IDC_POSITIVE;
				data->positive[i] = (int) IsDlgButtonChecked(hDlg, id);
				updateOutput = TRUE;
				return TRUE;
			case IDC_BW:
			case IDC_BW2:
			case IDC_BW3:
				i = id - IDC_BW;
				data->blackwhite[i] = (int) IsDlgButtonChecked(hDlg, id);
				updateOutput = TRUE;
				return TRUE;
			case IDC_EDIT_MEAN:
			case IDC_EDIT_GAUSSIAN:
			case IDC_EDIT_LAPLACIAN:
				i = id - IDC_EDIT_MEAN;
				data->curve[i] = GetDlgItemInt(hDlg, id, NULL, TRUE);
				hCtrl = GetDlgItem(hDlg, IDC_SCROLLBAR_MEAN + i);
				SetScrollPos(hCtrl, SB_CTL, data->curve[i], TRUE);
				updateOutput = TRUE;
				return TRUE;
			case IDOK:
				// Validate and Make the changes
				hwndParent = GetParent(hDlg);
				for (i = 0; i < 3; i++)
				{
					hCtrl = GetDlgItem(hDlg, IDC_POSITIVE + i);
					data->positive[i] = (int) SendMessage(hCtrl, BM_GETCHECK, 0, 0);
				
					//hCtrl = GetDlgItem(hDlg, IDC_COMBO1 + i);
					//data->sign[i] = SendMessage(hCtrl, CB_GETCURSEL, 0, 0) + 1;

				}
				InvalidateRect(hwndParent, NULL, TRUE);
				//EndDialog(hDlg,TRUE);
				DestroyWindow(hDlg);
				hDlgModeless = 0;
				updateOutput = TRUE;
				break;
			case IDCANCEL:
				*data = oldData;
				//EndDialog(hDlg,TRUE);
				DestroyWindow(hDlg);
				hDlgModeless = 0;
				updateOutput = TRUE;
				break;
			}
		}
		break;
		
		// Closed from sysbox
	case WM_CLOSE:
		//EndDialog(hDlg,TRUE);
		DestroyWindow(hDlg);
		hDlgModeless = 0;
		break;
	}
	
	return FALSE;
}



// Dialog procedure.
BOOL CALLBACK AboutDlgProc (HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	char	*str;
	
	switch (message)
	{
		// Initialize the dialog box
	case WM_INITDIALOG:
		{
			return (TRUE);
		}
		break;
		
		// Process command messages
	case WM_COMMAND:      
		{
			// Validate and Make the changes
			if(LOWORD(wParam) == IDOK)
				EndDialog(hDlg,TRUE);
		}
		break;
		
		// Closed from sysbox
	case WM_CLOSE:
		EndDialog(hDlg,TRUE);
		break;
	}
	
	return FALSE;
}
