#ifndef _LINKLIST_H_
#define _LINKLIST_H_



class ListItem
{
public:
	ListItem(void* data);
	~ListItem();
	void*		GetItem();
	ListItem*	Next();
	ListItem*	Prev();
	void		SetNext(ListItem *next);
	void		SetPrev(ListItem *prev);
private:
	void*		m_data;
	ListItem*	m_prev;
	ListItem*	m_next;
};


class LinkList
{
public:
	LinkList();
	~LinkList();
	void InsertItem(ListItem *item);
	void InsertItemData(void *data);
	void InsertItemAt(ListItem *item, int pos);
	void DeleteItemAt(int pos);
	void DeleteItem(void* data);
	int	GetPosOfItem(void* data);
	int	GetNumItem();
	ListItem* GetItemAt(int pos);
	void* GetItemDataAt(int pos);
	void EmptyList();
private:
	ListItem*	m_head;
	ListItem*	m_tail;
	int			m_numItem;
};

#endif //_LINKLIST_H_