#ifndef _POLYGON_H_
#define _POLYGON_H_

#include "gl\gl.h"


class Vertex
{
public:
	GLfloat v[3];

	Vertex() {v[0] = v[1] = v[2] = 0;}
	Vertex(GLfloat x, GLfloat y, GLfloat z) {v[0] = x; v[1] = y; v[2] = z;}
};

class Face
{
private:
	int m_numVertex;
	int *m_vertexList;
public:
	Face();
	Face(int num);
	~Face();
	int NumVertex() { return m_numVertex;}
	int* GetVertexList() { return m_vertexList;}
};

class Model
{
private:
	int	m_glListID;

	int m_numVertex;
	Vertex *m_vertex;
	int m_numVNormal;
	Vertex *m_vertexNormal;
	Vertex m_center;
	int m_numFace;
	Face *m_face;
public:
	Model();
	~Model();
	void	GLDraw();
	void	GLCompileList();
	int		GetListID() { return m_glListID;}
	void	SetNumVertex(int num);
	void	SetNumVertexNormal(int num);
	void	SetNumFace(int num);
	Vertex* GetVertex() {return m_vertex;}
	Vertex* GetVertexNormal() {return m_vertexNormal;}
	Face*	GetFace() {return m_face;}
};


#endif //_POLYGON_H_