/*===========================
Smooth - CS631 HW1 Part 1

Glen Chang - 456833
-------------------------------
main.cpp
==============================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pgm.h"

/*
int main(int argc, char *argv[])
{
	int	radius = 1;
	int	error = 0;
	char *temp;
	char *srcFile, *destFile;
	PgmFileInfoPtr	 srcInfo, destInfo;

	if (argc == 4)
	{
		radius = (int) strtod(argv[3], &temp);
	}
	else if (argc == 3)
	{
		radius = 1;
	}
	else 
	{
		printf("Usage: smooth <src.pgm> <dest.pgm> [#radius]\n");
		exit(0);
	}
	srcFile = argv[1];
	destFile = argv[2];

	srcInfo = destInfo = NULL;
	srcInfo = new PgmFileInfo;
	if (srcInfo == NULL)
	{
		error = 3;
		goto CLEANUP;
	}
	destInfo = new PgmFileInfo;
	if (destInfo == NULL)
	{
		error = 3;
		goto CLEANUP;
	}
	srcInfo->data = destInfo->data = NULL;

	error = PgmReadFile(srcFile, srcInfo);
	if (error != 0)
		exit(error);
	error = PgmSmooth(srcInfo, destInfo, radius);
	if (error != 0)
		exit(error);
	error = PgmWriteFile(destFile, destInfo);
	
CLEANUP:
	if (srcInfo != NULL)
	{
		if (srcInfo->data != NULL)
			delete []srcInfo->data;
		delete srcInfo;
		srcInfo = NULL;
	}
	if (destInfo != NULL)
	{
		if (destInfo->data != NULL)
			delete []destInfo->data;
		delete destInfo;
		destInfo = NULL;
	}
	return error;
}

//Read a PGM source file
int PgmReadFile(char *srcFile, PgmFileInfoPtr srcInfo)
{
	FILE	*fp;
	int		error, tSize;
	char	temp[256];

	error = 1;
	fp = fopen(srcFile, "rb");
	if (fp == NULL)
		return error;
	do
	{
		fscanf(fp, "%s\n", temp);
	} while (temp[0] == '#');

	if (strncmp(temp, "P5", 2) != 0)
	{
		printf("Incorrect magic number.\n");
		error = 2;
		goto CLEANUP;
	}

	do
	{
		fscanf(fp, "%s\n", temp);
	} while (temp[0] == '#');

	sscanf(temp, "%d", &(srcInfo->width));
	fscanf(fp, "%s\n", temp);
	sscanf(temp, "%d",  &(srcInfo->height));
	do
	{
		fscanf(fp, "%s\n", temp);
	} while (temp[0] == '#');

	sscanf(temp, "%d", &(srcInfo->maxGrayValue));
	tSize = srcInfo->width * srcInfo->height;
	srcInfo->data = new unsigned char[tSize];
	if (srcInfo->data == NULL)
	{
		error = 3;
		goto CLEANUP;
	}
	if (fread(srcInfo->data, 1, tSize, fp) < (size_t) tSize)
	{
		error = 4;
		goto CLEANUP;
	}
CLEANUP:
	if (fp != NULL)
		fclose(fp);
	fp = NULL;
	return 0;
}

//Perform smooth function into a new PGM data struct
int PgmSmooth(PgmFileInfoPtr srcInfo, PgmFileInfoPtr destInfo, int radius)
{
	int error = 0;
	int	i, j, x, y, xPos, yPos, size, diameter, maskSize;
	int	sum;
	unsigned char	value;
	char	*mask;

	destInfo->width = srcInfo->width;
	destInfo->height = srcInfo->height;
	destInfo->maxGrayValue = srcInfo->maxGrayValue;
	size = destInfo->width * destInfo->height;
	destInfo->data = new unsigned char[size];
	if (destInfo->data == NULL)
	{
		error = 3;
		goto CLEANUP;
	}
	memset(destInfo->data, 0, size);
	diameter = 2 * radius + 1;
	maskSize = diameter * diameter;
	//mask = new char[maskSize];
	
	for (x = 0; x < srcInfo->width; x++)
	{
		for (y = 0; y < srcInfo->height; y++)
		{
			sum = 0;
			for (i = -radius; i <= radius; i++)
			{
				for (j = -radius; j <= radius; j++)
				{
					if (x + i >= srcInfo->width)
						xPos = x - i + 1;
					else if(x + i < 0)
						xPos = x - i - 1;
					else 
						xPos = x + i;
					if (y + j >= srcInfo->height)
						yPos = y - j + 1;
					else if (y + j < 0)
						yPos = y - j - 1;
					else 
						yPos = y + j;
					value = srcInfo->data[yPos * srcInfo->width + xPos];
					sum += value;
				}
			}
			sum /= maskSize;
			destInfo->data[y * srcInfo->width + x] = (unsigned char) sum;
		}
	}
CLEANUP:
	//if (mask != NULL)
	//	delete []mask;
	//mask = NULL;
	return error;
}
*/
//Write a PGM file 
int PgmWriteFile(char *destFile, PgmFileInfoPtr destInfo)
{
	FILE *fp;
	char	temp[256];
	size_t	size;

	fp = fopen(destFile, "wb");
	if (fp == NULL)
		return 1;
	size = sprintf(temp, "P5\n%d %d\n%d\n", destInfo->width, destInfo->height, destInfo->maxGrayValue);
	if (fwrite(temp, 1, size, fp) <  size)
		return 4;
	size = destInfo->width * destInfo->height;
	if (fwrite(destInfo->data, 1, size, fp) < size)
		return 4;

	if (fp != NULL)
		fclose(fp);
	fp = NULL;
	return 0;
}